/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Launchy
 *
 * The Initial Developer of the Original Code is Henrik Gemal.
 * Portions created by the Initial Developer are Copyright (C) 2003-2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Henrik Gemal <launchy@gemal.dk> http://gemal.dk
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var LaunchyShared = function() {}

// Dump message to the JavaScript console but only if you're a developer
LaunchyShared.prototype.trace = function(t) {
	if (typeof(LaunchyContext.dev) != "undefined" && LaunchyContext.dev) {
		try {
			var CONSOLE_SERVICE = Components.classes['@mozilla.org/consoleservice;1'].getService(Components.interfaces.nsIConsoleService);
			CONSOLE_SERVICE.logStringMessage("launchy: " + t);
		} catch(ex) {
			alert(t);
		}
	}
}

LaunchyShared.prototype.help = function() {
	try {
		if (typeof(loadThrobberUrl) != "undefined") {
			messenger.launchExternalURL("http://gemal.dk/mozilla/launchy.html?ver=" + LaunchyContext.version);
		} else {
			openTopWin("http://gemal.dk/mozilla/launchy.html?ver=" + LaunchyContext.version);
		}
	} catch(ex) {
		launchyShared.trace("Unable to launch URL due to " + ex);
	}
}

LaunchyShared.prototype.uninstall = function() {
	if (!LaunchyContext.launchy) {
		alert(document.getElementById("bundle_launchy").getString("launchy-uninstall-failure"));
		return;
	}
	try {
		jslibUninstall('launchy')
	} catch(ex) {
		launchyShared.trace("Uninstall of launchy not ok: " + ex);
	}
}

LaunchyShared.prototype.replaceInsert = function(t, i, v) {
	var result = t;
	var re = new RegExp("#" + i);
	result = result.replace(re, v);
	return result;
}

// create the object
const launchyShared = new LaunchyShared();
